'Print Preview Include Demonstration by Gary Beene  ver 5.12     16 Dec 2013
'This code is released to public domain. There are no restrictions on its use.

'Features:
'Visit the home page for feature information:  http://www.garybeene.com/sw/gbprintpreview.htm

'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbprintpreview_demo.exe"
#Dim All
%Unicode=1

#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

#Include "Win32api.inc"

$DemoVer = "5.12"
$PPData  = "tempfiles\ppdata.dat"

Enum Equates Singular
   IDC_Toolbar = 500
   IDC_SampleText
   IDC_StatusBar
   IDC_MinPage
   IDC_MaxPage
   IDC_LabelA
   IDC_LabelB

   IDT_SelectFile
   IDT_PrintPreview
   IDT_SampleText
   IDT_QuietPrint
   IDT_AutoPreview
   IDT_Help
End Enum

#Include "gbprintpreview.inc"

#Resource Icon logo "images\ppprintall.ico"
#Resource Icon mquiet "images\ppquiet.ico"
#Resource Icon mauto "images\ppstart.ico"
#Resource Icon mhelp "images\pphelp.ico"
#Resource Icon mopen "images\ppopen.ico"
#Resource Icon msample "images\pplist.ico"

'Global Program Variables ======================================================================
Global hDlg,hCFont As Dword               'working variables
Global PP As PPPrintPreviewData           'data to pass to gbPrintPreview
Global AutoPreview, SampleNumber As Long  'INI variables
Global FileName As WStringZ * %Max_Path   'INI variables
Global FileContent As String

Function PBMain() As Long
   Local Style As Long
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll _
      Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %WS_Border
   Dialog New Pixels, 0, "gbPrintPreview Demo  v" + $DemoVer,100,100,500,400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   Control Add Label, hDlg, %IDC_LabelB, "Sample Text:", 10, 90, 110, 20
   Control Add TextBox, hDlg, %IDC_SampleText, "", 10, 110, 250, 250, Style '<--- Sample Text

   Control Add Label, hDlg, %IDC_LabelA, "Quiet Print Range:", 10, 60, 110, 20
   Control Add TextBox, hDlg, %IDC_MinPage, "1", 130, 60, 30, 20
   Control Add TextBox, hDlg, %IDC_MaxPage, "2", 170, 60, 30, 20

   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PTT As TooltipText Ptr, i As Long, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
         If IsFile($PPData) Then GetPPValues Else SetPPValues
         Settings_ini "get"
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AutoPreview,  IIf(AutoPreview,AutoPreview,0) Or %TBState_Enabled
         Font New "Tahoma",10,0 To hCFont
         For i = %IDC_Toolbar To %IDC_LabelB : Control Set Font hDlg, i, hCFont : Next i
         If IsFile(FileName) Then
            LoadFileName
         Else
            Control Set Text hDlg, %IDC_SampleText, SampleText
         End If
         Control Post hDlg, %IDC_SampleText, %EM_SETSEL, -1, 0    'stop
         Statusbar Set Text hdlg, %IDC_StatusBar, 1, 0, IIf$(Len(FileName), FileName, "<no filename specified>")
         If AutoPreview Then Dialog Post hDlg, %WM_User + 500, 0, 0

      Case %WM_User + 500
         Dialog Set Text hDlg, "gbPrintPreview Demo  v" + $DemoVer + "     GDI Count: " + Str$(GetGDICount(hDlg))
         UpdatePPValues
         gbPrintPreview PP, FileContent  'call the gbPrinter Dialog
         UpdateDemoApp  'do something with the returned values
         Dialog Set Text hDlg, "gbPrintPreview Demo  v" + $DemoVer + "     GDI Count: " + Str$(GetGDICount(hDlg))

      Case %WM_Destroy
         Settings_ini "save"
         SavePPValues

      Case %WM_SetFocus
         Control Post hDlg, %IDC_SampleText, %EM_SETSEL, -1, 0    'stop

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_SampleText
               Incr SampleNumber
               If SampleNumber > 3 Then SampleNumber = 0
               Control Set Text hDlg, %IDC_SampleText, SampleText
               FileName = ""
               Statusbar Set Text hdlg, %IDC_StatusBar, 1, 0, IIf$(Len(FileName), FileName, "<no filename specified>")
            Case %IDT_SelectFile
               SelectAndOpenFile
            Case %IDT_PrintPreview
               Dialog Set Text hDlg, "gbPrintPreview Demo  v" + $DemoVer + "     GDI Count: " + Str$(GetGDICount(hDlg))
               UpdatePPValues
               gbPrintPreview PP, FileContent  'call the gbPrinter Dialog
               UpdateDemoApp  'do something with the returned values
               Dialog Set Text hDlg, "gbPrintPreview Demo  v" + $DemoVer + "     GDI Count: " + Str$(GetGDICount(hDlg))
            Case %IDT_QuietPrint
               Dialog Set Text hDlg, "gbPrintPreview Demo  v" + $DemoVer + "     GDI Count: " + Str$(GetGDICount(hDlg))
               UpdatePPValues
               gbPrintPreview PP, FileContent  'call the gbPrinter Dialog
               UpdateDemoApp  'do something with the returned values
               Dialog Set Text hDlg, "gbPrintPreview Demo  v" + $DemoVer + "     GDI Count: " + Str$(GetGDICount(hDlg))
            Case %IDT_AutoPreview
               AutoPreview Xor= 1
            Case %IDT_Help
               i = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbprintpreview.htm", $Nul, $Nul, %SW_ShowNormal)
         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_SelectFile To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_SelectFile   : @PTT.@lpszText = "Open New Files"
                        Case %IDT_AutoPreview  : @PTT.@lpszText = "Open gbPrintPreview Automatically When App Starts"
                        Case %IDT_PrintPreview : @PTT.@lpszText = "Display Print Preview Dialog"
                        Case %IDT_SampleText   : @PTT.@lpszText = "Cycle Through 3 Different Text Samples"
                        Case %IDT_QuietPrint   : @PTT.@lpszText = "Print Page Range Without Displaying Print Preview Dialog"
                        Case %IDT_Help         : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
         End Select

      Case %WM_Size
         Local w,h As Long
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_SampleText, w-20, h-140

   End Select
End Function

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "500", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "AutoPreview", "0", temp, %Max_Path, INIFileName:  AutoPreview = Val(temp)
      Getprivateprofilestring "All", "SampleNumber", "0", temp, %Max_Path, INIFileName:  SampleNumber = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "AutoPreview", Str$(AutoPreview), INIFileName
      WritePrivateProfileString "All", "SampleNumber", Str$(SampleNumber), INIFileName
   End If
End Sub

Sub CreateToolbar
   Local hImageList As Dword
   ImageList New Icon 24,24,24,10 To hImageList
   ImageList Add Icon hImageList, "logo"   '1
   ImageList Add Icon hImageList, "mquiet"  '2
   ImageList Add Icon hImageList, "mhelp"   '3
   ImageList Add Icon hImageList, "mauto"   '4
   ImageList Add Icon hImageList, "mopen"   '5
   ImageList Add Icon hImageList, "msample" '6
   Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat
   Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
   Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_SelectFile, %BTNS_Button, "Open"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_PrintPreview, %BTNS_Button, "Preview"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_QuietPrint,  %BTNS_Button, "Quiet"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_SampleText,  %BTNS_Button, "Sample"
   Toolbar Add Separator hDlg, %IDC_Toolbar, 20
   Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_AutoPreview,  %BTNS_Check, "AutoPreview"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button, "Help"
End Sub

Function SelectAndOpenFile As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, temp$
    filter$ = "Text Files (*.bas, *.txt, *.inc)" + $Nul + "*.bas;*.inc;*.txt" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = FileName       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       LoadFileName
       Statusbar Set Text hdlg, %IDC_StatusBar, 1, 0, IIf$(Len(FileName), FileName, "<no filename specified>")
    End If
End Function

Sub LoadFileName
   Local temp$
   Open FileName For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Control Set Text hDlg, %IDC_SampleText, temp$
End Sub

Function GetGDIcount(hWnd As Long) As Long
   Local hProcess As Dword
   getwindowthreadprocessid hWnd, hProcess
   hProcess = openprocess(%PROCESS_QUERY_INFORMATION Or %PROCESS_VM_READ, 0, hProcess)
   Function = getguiresources(hProcess, %GR_GDIOBJECTS)
End Function

Sub SetPPValues
   Local MinPage, MaxPage As Long, temp$
   'set print preview values, for passing to gbPrintPreview
   Control Get Text hDlg, %IDC_MinPage To temp$ : MinPage = Val(temp$)
   Control Get Text hDlg, %IDC_MaxPage To temp$ : MaxPage = Val(temp$)
   'settings
   PP.hParent                    = hDlg                   'handle to parent dialog
   PP.DialogX                    = 0                      'initial dialog x
   PP.DialogY                    = 100                    'initial dialog y
   PP.DialogW                    = 850                    'initial dialog w
   PP.DialogH                    = 500                    'initial dialog h

   'misc settings
   PP.FileName                   = FileName               'file name where text comes from
   PP.TextExtensions             = "*.bas;*.txt;*.inc;*.htm" 'extensions for text files

   'Quiet Printing setting
   PP.QuietPrint                 = 0                      'print without showing 0=no 1=all 2=range
   PP.QMinPage                   = MinPage                'starting page for quiet print
   PP.QMaxPage                   = MaxPage                'ending page for quiet print


   'Printer Settings
   PP.PrinterName                = ""                     'printer name (default = "") Example: "\\NANCY-PC\Brother HL_2240D series"
   PP.Orientation                = 1                      'initial orientation 0=landscape 1=portrait
   PP.PaperSizeW                 = 8.5                    'full paper width
   PP.PaperSizeH                 = 11.0                   'full paper height
   PP.MarginTop                  = 1.0                    'top margin - inches
   PP.MarginLeft                 = 1.0                    'left margin - inches
   PP.MarginBottom               = 1.0                    'bottom margin - inches
   PP.MarginRight                = 1.0                    'right margin - inches
   PP.AutoClose                  = 0                      'autoclose on print  1=yes 0=no

   'Main Body Setting
   PP.ShowMargins                = 1                      'show margins  1=yes 0=no
   PP.WordWrap                   = 1                      'wordwrap  1=yes 0=no
   PP.ZoomFactor                 = 5                      'zoom factor zoom factor 1=fit_inside  2=dual page  3=fit_width  4=25% 5=50% 6=75% 7=100% 8=200% 9=400$
   PP.TextColor                  = %Black                 'color of text (header/footer/main)
   PP.FontName                   = "Times New Roman"      'font name (main text)
   PP.FontPoints                 = 10                     'font size (points) (main text)
   PP.FontPointsSF               = 10                     'font size (points) (main text)
   PP.FontStyle                  = 0                      'font style  0=normal 1=bold (main text)
   PP.LineNumbers                = 0                      'show line numbers on text
   PP.CustomFF                   = 1                      'use custom form feed text
   PP.CustomFFText               = ".Page"                'string that indicates a page break
   PP.SortMethod                 = 0                      '0=none 1=Ascending 2=Descending
   PP.Justify                    = 0                      '0=no 1=yes
   PP.Unix                       = 0                      'indicates use of $crlf or $lf

   'Background settings
   PP.ShowBGImage                = 0                      'show background image
   PP.GrayScaleBG                = 0                      '0=no 1=yes
   PP.LightenBG                  = 0                      '0=no 1=yes
   PP.NaturalBG                  = 0                      '0=no 1=yes
   PP.BGImageName                = Exe.Path$ + "background\archer.jpg"   'background image name, not use if ""
   PP.BGColor                    = %White                 'background document color

   'Header Settings
   PP.ShowHeader                 = 1                      'show header  1=yes 0=no
   PP.ShowHeaderImage            = 1                      'show header image
   PP.GrayScaleH                 = 0                      'apply gray scale to Header image
   PP.LightenH                   = 0                      'apply lighten filter to Header image
   PP.HeaderImageBorder          = 1                      'draw black border around Header image
   PP.HeaderImageName            = Exe.Path$ + "background\chess.jpg"     'header image file name
   PP.HeaderHeight               = 1.0                    'header height - inches
   PP.HeaderImageContW           = 2.0                    'header image container width - inches
   PP.HeaderImageContH           = 1.0                    'header image container height - inches
   PP.HeaderNatural              = 0                      '0=no 1=yes
   PP.TopLeftText                = "<d>"                  'header string - top left
   PP.TopCenterText              = "<pagen>"                  'header string - top center
   PP.TopRightText               = "<t>"               'header string - top right
   PP.FontNameH                  = "Arial"                'font name (header)
   PP.FontPointsH                = 12                     'font size (header)
   PP.FontPointsHSF              = 12                     'font size (header)
   PP.FontStyleH                 = 1                      'font style (header)  0=normal 1=bold

   'Footer Settings
   PP.ShowFooter                 = 1                      'show footer  1=yes 0=no
   PP.ShowFooterImage            = 1                      'show footer image
   PP.GrayScaleF                 = 0                      'apply gray scale to Footer image
   PP.LightenF                   = 0                      'apply lightening filter to Footer image
   PP.FooterImageBorder          = 1                      'draw black border around Footer image
   PP.FooterImageName            = Exe.Path$ + "background\cowgirl.bmp"   'footer image file name
   PP.FooterHeight               = 1.0                    'footer height - inches
   PP.FooterImageContW           = 2.0                    'footer image container width - inches
   PP.FooterImageContH           = 1.0                    'footer image container height - inches
   PP.FooterNatural              = 0                      '0=no 1=yes
   PP.BottomLeftText             = "<page>"               'footer string - top left
   PP.BottomCenterText           = "<filename>"           'footer string - top center
   PP.BottomRightText            = "<page>"              'footer string - top right
   PP.FontNameF                  = "Arial"                'font name (footer)
   PP.FontPointsF                = 12                     'font size (footer)
   PP.FontPointsFSF              = 12                     'font size (footer)
   PP.FontStyleF                 = 1                      'font style (footer)  0=normal 1=bold
End Sub

Function SampleText() As String
   Local temp As String
   Select Case SampleNumber
      Case 0
         temp = "                           Welcome to gbPrintPreview"
         temp = temp + $CrLf + $CrLf + "gbPrintPreview allows programmers to add print preview of text files to their applications. "
         temp = temp + "As a DLL, gbPrintPreview can be easily added to easily applications with only a few modifications. Source code is also available and allows the programmer to integrate gbPrintPreview features directly into their applications.""
         temp = temp + "A stand alone file viewer, which includes gbPrintPreview features, is also included in the gbPrintPreview distribution"
         temp = temp + $CrLf + $CrLf
         temp = temp + "Preview of files can be done at various zoom factors, up to 400%. "
         temp = temp + "Header and footers are supported, each with the option to include images."
         temp = temp + "Printer selection, margin setting, portrait/landscape selection, page numbering are just a few of gbPrintPreview's features."
         temp = temp + "Printing of individual pages, a page range, or the entire document is supported.
         temp = temp + $CrLf + $CrLf
         temp = temp + "gbPrintPreview is available at http://www.garybeene.com/sw/gbprintpreviewnippets.htm" + $CrLf + $CrLf
         Function = Trim$(Repeat$(10,temp), $CrLf)
      Case 1
         temp = "                           Welcome to gbPrintPreview"
         temp = temp + $CrLf + $CrLf + "gbPrintPreview allows programmers to add print preview of text files to their applications. "
         temp = temp + "As a DLL, gbPrintPreview can be easily added to easily applications with only a few modifications. Source code is also available and allows the programmer to integrate gbPrintPreview features directly into their applications.""
         temp = temp + $CrLf + ".Page" + $CrLf
         temp = temp + "A stand alone file viewer, which includes gbPrintPreview features, is also included in the gbPrintPreview distribution"
         temp = temp + $CrLf + ".Page" + $CrLf
         temp = temp + "Preview of files can be done at various zoom factors, up to 400%. "
         temp = temp + "Header and footers are supported, each with the option to include images."
         temp = temp + $CrLf + $CrLf + "Printer selection, margin setting, portrait/landscape selection, page numbering are just a few of gbPrintPreview's features."
         temp = temp + "Printing of individual pages, a page range, or the entire document is supported.
         temp = temp + $CrLf + ".Page" + $CrLf
         temp = temp + "gbPrintPreview is available at http://www.garybeene.com/sw/gbprintpreviewnippets.htm" + $CrLf + $CrLf
         Function = Trim$(temp,$CrLf)
      Case 2
         temp = " code"
         temp = temp + $CrLf + "    program"
         temp = temp + $CrLf + "    Loop"
         temp = temp + $CrLf + "    While"
         temp = temp + $CrLf + "function"
         temp = temp + $CrLf + "procedure"
         temp = temp + $CrLf + "  loop"
         temp = temp + $CrLf + "  while" + $CrLf
         temp = Repeat$(10,temp)
         Function = Trim$(temp,$CrLf)
      Case 3
         temp = "                           Welcome to gbPrintPreview"
         temp = temp + $CrLf + $CrLf + "gbPrintPreview allows programmers to add print preview of text files to their applications. "
         temp = temp + "As a DLL, gbPrintPreview can be easily added to easily applications with only a few modifications. Source code is also available and allows the programmer to integrate gbPrintPreview features directly into their applications.""
         temp = temp + "A stand alone file viewer, which includes gbPrintPreview features, is also included in the gbPrintPreview distribution"
         temp = temp + $CrLf + $CrLf
         temp = temp + "Preview of files can be done at various zoom factors, up to 400%. "
         temp = temp + "Header and footers are supported, each with the option to include images."
         temp = temp + "Printer selection, margin setting, portrait/landscape selection, page numbering are just a few of gbPrintPreview's features."
         temp = temp + "Printing of individual pages, a page range, or the entire document is supported.
         temp = temp + $CrLf + $CrLf
         temp = temp + "gbPrintPreview is available at http://www.garybeene.com/sw/gbprintpreviewnippets.htm" + $CrLf + $CrLf
         Function = Trim$(Repeat$(1000,temp), $CrLf)
   End Select
End Function

Sub UpdateDemoApp
   'filename change requires action on the part of the Demo App
   If FileName <> PP.FileName Then
      Select Case MsgBox("FileName has changed. Accept change and update TextBox?", %MB_YesNo Or %MB_IconQuestion, "File Name Changed")
         Case %IdYes
            FileName = PP.FileName
            Statusbar Set Text hdlg, %IDC_StatusBar, 1, 0, IIf$(Len(FileName), FileName, "<no filename specified>")
            LoadFileName
         Case %IdNo
            PP.FileName = FileName
      End Select
   End If
End Sub

Sub SavePPValues
   Open $PPData For Binary As #1
   Put#1, , PP
   SetEof(1)
   Close #1
End Sub

Sub GetPPValues
   Open $PPData For Binary As #1
   Get #1, , PP
   Close #1
End Sub

Sub UpdatePPValues
   Local temp$
   PP.QuietPrint = 0
   PP.hParent = hDlg
   Control Get Text hDlg, %IDC_MinPage To temp$ : PP.QMinPage = Val(temp$)
   Control Get Text hDlg, %IDC_MaxPage To temp$ : PP.QMaxPage = Val(temp$)
   Control Get Text hDlg, %IDC_SampleText To FileContent
End Sub
